diff --git a/src/backend/nodes/copyfuncs.c b/src/backend/nodes/copyfuncs.c
new file mode 100644
index 930f2f1..59836ba
*** a/src/backend/nodes/copyfuncs.c
--- b/src/backend/nodes/copyfuncs.c
*************** _copyAggref(const Aggref *from)
*** 1245,1250 ****
--- 1245,1251 ----
  	COPY_SCALAR_FIELD(aggstar);
  	COPY_SCALAR_FIELD(aggvariadic);
  	COPY_SCALAR_FIELD(aggkind);
+ 	COPY_SCALAR_FIELD(aggtransmultifn);
  	COPY_SCALAR_FIELD(agglevelsup);
  	COPY_SCALAR_FIELD(aggsplit);
  	COPY_LOCATION_FIELD(location);
diff --git a/src/backend/nodes/outfuncs.c b/src/backend/nodes/outfuncs.c
new file mode 100644
index 806d0a9..8e789fe
*** a/src/backend/nodes/outfuncs.c
--- b/src/backend/nodes/outfuncs.c
*************** _outPlannerInfo(StringInfo str, const Pl
*** 2046,2051 ****
--- 2046,2053 ----
  	WRITE_NODE_FIELD(append_rel_list);
  	WRITE_NODE_FIELD(rowMarks);
  	WRITE_NODE_FIELD(placeholder_list);
+ 	WRITE_NODE_FIELD(grouped_var_list);
+ 	WRITE_BOOL_FIELD(all_baserels_grouped);
  	WRITE_NODE_FIELD(fkey_list);
  	WRITE_NODE_FIELD(query_pathkeys);
  	WRITE_NODE_FIELD(group_pathkeys);
diff --git a/src/backend/optimizer/geqo/geqo_eval.c b/src/backend/optimizer/geqo/geqo_eval.c
new file mode 100644
index b5cab0c..f89406d
*** a/src/backend/optimizer/geqo/geqo_eval.c
--- b/src/backend/optimizer/geqo/geqo_eval.c
*************** merge_clump(PlannerInfo *root, List *clu
*** 265,271 ****
  			if (joinrel)
  			{
  				/* Create GatherPaths for any useful partial paths for rel */
! 				generate_gather_paths(root, joinrel);
  
  				/* Find and save the cheapest paths for this joinrel */
  				set_cheapest(joinrel);
--- 265,271 ----
  			if (joinrel)
  			{
  				/* Create GatherPaths for any useful partial paths for rel */
! 				generate_gather_paths(root, joinrel, false);
  
  				/* Find and save the cheapest paths for this joinrel */
  				set_cheapest(joinrel);
diff --git a/src/backend/optimizer/path/allpaths.c b/src/backend/optimizer/path/allpaths.c
new file mode 100644
index 46d7d06..0ae0a1b
*** a/src/backend/optimizer/path/allpaths.c
--- b/src/backend/optimizer/path/allpaths.c
***************
*** 24,29 ****
--- 24,30 ----
  #include "catalog/pg_operator.h"
  #include "catalog/pg_proc.h"
  #include "foreign/fdwapi.h"
+ #include "miscadmin.h"
  #include "nodes/makefuncs.h"
  #include "nodes/nodeFuncs.h"
  #ifdef OPTIMIZER_DEBUG
***************
*** 44,49 ****
--- 45,51 ----
  #include "parser/parsetree.h"
  #include "rewrite/rewriteManip.h"
  #include "utils/lsyscache.h"
+ #include "utils/selfuncs.h"
  
  
  /* results of subquery_is_pushdown_safe */
*************** static void set_rel_pathlist(PlannerInfo
*** 76,81 ****
--- 78,85 ----
  static void set_plain_rel_size(PlannerInfo *root, RelOptInfo *rel,
  				   RangeTblEntry *rte);
  static void create_plain_partial_paths(PlannerInfo *root, RelOptInfo *rel);
+ static void create_plain_grouped_path(PlannerInfo *root, RelOptInfo *rel,
+ 									  Path *subpath);
  static void set_rel_consider_parallel(PlannerInfo *root, RelOptInfo *rel,
  						  RangeTblEntry *rte);
  static void set_plain_rel_pathlist(PlannerInfo *root, RelOptInfo *rel,
*************** set_rel_pathlist(PlannerInfo *root, RelO
*** 457,463 ****
  	 * we'll consider gathering partial paths for the parent appendrel.)
  	 */
  	if (rel->reloptkind == RELOPT_BASEREL)
! 		generate_gather_paths(root, rel);
  
  	/*
  	 * Allow a plugin to editorialize on the set of Paths for this base
--- 461,470 ----
  	 * we'll consider gathering partial paths for the parent appendrel.)
  	 */
  	if (rel->reloptkind == RELOPT_BASEREL)
! 	{
! 		generate_gather_paths(root, rel, false);
! 		generate_gather_paths(root, rel, true);
! 	}
  
  	/*
  	 * Allow a plugin to editorialize on the set of Paths for this base
*************** set_plain_rel_pathlist(PlannerInfo *root
*** 656,662 ****
  	required_outer = rel->lateral_relids;
  
  	/* Consider sequential scan */
! 	add_path(rel, create_seqscan_path(root, rel, required_outer, 0));
  
  	/* If appropriate, consider parallel sequential scan */
  	if (rel->consider_parallel && required_outer == NULL)
--- 663,669 ----
  	required_outer = rel->lateral_relids;
  
  	/* Consider sequential scan */
! 	add_path(rel, create_seqscan_path(root, rel, required_outer, 0), false);
  
  	/* If appropriate, consider parallel sequential scan */
  	if (rel->consider_parallel && required_outer == NULL)
*************** static void
*** 677,682 ****
--- 684,690 ----
  create_plain_partial_paths(PlannerInfo *root, RelOptInfo *rel)
  {
  	int			parallel_workers;
+ 	Path	   *path;
  
  	/*
  	 * If the user has set the parallel_workers reloption, use that; otherwise
*************** create_plain_partial_paths(PlannerInfo *
*** 727,733 ****
  		return;
  
  	/* Add an unordered partial path based on a parallel sequential scan. */
! 	add_partial_path(rel, create_seqscan_path(root, rel, NULL, parallel_workers));
  }
  
  /*
--- 735,888 ----
  		return;
  
  	/* Add an unordered partial path based on a parallel sequential scan. */
! 	path = create_seqscan_path(root, rel, NULL, parallel_workers);
! 	add_partial_path(rel, path, false);
! 
! 	/*
! 	 * Do partial aggregation at base relation level if the relation is
! 	 * eligible for it.
! 	 */
! 	if (rel->reltarget_grouped)
! 		create_plain_grouped_path(root, rel, path);
! }
! 
! /*
!  * Apply (partial) aggregation to partial subpath.
!  *
!  * As we modify the subpath here, copy is taken before we adjust it.
!  */
! static void
! create_plain_grouped_path(PlannerInfo *root, RelOptInfo *rel, Path *subpath)
! {
! 	Query	   *parse = root->parse;
! 	ListCell	*lc;
! 	Expr		*texpr;
! 	AggClauseCosts  agg_costs;
! 	AggPath		*agg_path;
! 	List    *group_clause = NIL;
! 	List	*group_exprs = NIL;
! 	List	*agg_exprs = NIL;
! 	bool	can_hash;
! 	Size	hashaggtablesize;
! 	int		i;
! 	double	dNumGroups;
! 	Path	*subpath_tmp;
! 	PathTarget	*target = rel->reltarget_grouped;
! 
! 	/* Copy the subpath before doing changes. */
! 	subpath_tmp = makeNode(Path);
! 	memcpy(subpath_tmp, subpath, sizeof(Path));
! 	subpath = subpath_tmp;
! 
! 	/* Apply the specific target. */
! 	subpath->pathtarget = target;
! 
! 	/*
! 	 * Find one grouping clause per grouping column.
! 	 *
! 	 * The "grouped target" should contain grouping expressions, and these
! 	 * should have non-zero sortgroupref.
! 	 */
! 	Assert(target->sortgrouprefs != NULL);
! 
! 	i = 0;
! 	foreach(lc, target->exprs)
! 	{
! 		Index	sortgroupref;
! 		SortGroupClause *cl;
! 
! 		texpr = (Expr *) lfirst(lc);
! 		sortgroupref = target->sortgrouprefs[i++];
! 
! 		if (sortgroupref == 0)
! 		{
! 			/*
! 			 * Looks like "grouped var" representing Aggref - these should
! 			 * appear at the end of the list.
! 			 */
! 			break;
! 		}
! 
! 		/*
! 		 * Find the clause by sortgroupref.
! 		 *
! 		 * All that create_agg_plan eventually needs of the clause is
! 		 * tleSortGroupRef, so we don't have to care that the clause
! 		 * expression might differ from texpr, in case texpr was derived from
! 		 * EC.
! 		 */
! 		cl = get_sortgroupref_clause(sortgroupref, root->parse->groupClause);
! 		group_clause = lappend(group_clause, cl);
! 		group_exprs = lappend(group_exprs, texpr);
! 	}
! 
! 	/* Now collect the aggregates. */
! 	while (lc != NULL)
! 	{
! 		texpr = (Expr *) lfirst(lc);
! 
! 		/*
! 		 * texpr still contains the replacement var, so restore the actual
! 		 * Aggref expression.
! 		 */
! 		Assert(IsA(texpr, Var));
! 		agg_exprs = lappend(agg_exprs, find_grouped_var_expr(root,
! 															 (Var *) texpr));
! 		lc = lnext(lc);
! 	}
! 
! 	Assert(agg_exprs != NIL);
! 	MemSet(&agg_costs, 0, sizeof(AggClauseCosts));
! 	get_agg_clause_costs(root, (Node *) agg_exprs, AGGSPLIT_INITIAL_SERIAL,
! 						 &agg_costs);
! 
! 	can_hash = (parse->groupClause != NIL &&
! 				parse->groupingSets == NIL &&
! 				agg_costs.numOrderedAggs == 0 &&
! 				grouping_is_hashable(parse->groupClause));
! 
! 	/* TODO Consider other kinds of aggregation. */
! 	if (!can_hash)
! 		return;
! 
! 	Assert(group_exprs != NIL);
! 	dNumGroups = estimate_num_groups(root, group_exprs, subpath->rows, NULL);
! 
! 	hashaggtablesize = estimate_hashagg_tablesize(subpath, &agg_costs,
! 												  dNumGroups);
! 
! 	if (hashaggtablesize < work_mem * 1024L)
! 	{
! 		/*
! 		 * Create the partial aggregation path.
! 		 *
! 		 * Note that target contains "grouped vars" (see GroupedVarInfo)
! 		 * instead of Aggref expressions so far. Thus set_upper_references can
! 		 * easily link TLEs of the upper node (which is not necessarily the
! 		 * final Agg node) to the output of the patial Agg plan. Once
! 		 * descended to this partial Agg node, set_upper_references will
! 		 * install the Aggref expressions.
! 		 */
! 		Assert(group_clause != NIL);
! 		agg_path = create_agg_path(root,
! 								   rel,
! 								   subpath,
! 								   target,
! 								   AGG_HASHED,
! 								   AGGSPLIT_INITIAL_SERIAL,
! 								   group_clause,
! 								   NIL,
! 								   &agg_costs,
! 								   dNumGroups);
! 
! 		/*
! 		 * The agg path should require no fewer parameters than the plain one.
! 		 */
! 		agg_path->path.param_info = subpath->param_info;
! 
! 		/* Finally add the grouped path to the list of grouped base paths. */
! 		add_partial_path(rel, (Path *) agg_path, true);
! 	}
  }
  
  /*
*************** set_tablesample_rel_pathlist(PlannerInfo
*** 813,819 ****
  		path = (Path *) create_material_path(rel, path);
  	}
  
! 	add_path(rel, path);
  
  	/* For the moment, at least, there are no other paths to consider */
  }
--- 968,974 ----
  		path = (Path *) create_material_path(rel, path);
  	}
  
! 	add_path(rel, path, false);
  
  	/* For the moment, at least, there are no other paths to consider */
  }
*************** set_append_rel_pathlist(PlannerInfo *roo
*** 1267,1273 ****
  	 * if we have zero or one live subpath due to constraint exclusion.)
  	 */
  	if (subpaths_valid)
! 		add_path(rel, (Path *) create_append_path(rel, subpaths, NULL, 0));
  
  	/*
  	 * Consider an append of partial unordered, unparameterized partial paths.
--- 1422,1429 ----
  	 * if we have zero or one live subpath due to constraint exclusion.)
  	 */
  	if (subpaths_valid)
! 		add_path(rel, (Path *) create_append_path(rel, subpaths, NULL, 0),
! 				 false);
  
  	/*
  	 * Consider an append of partial unordered, unparameterized partial paths.
*************** set_append_rel_pathlist(PlannerInfo *roo
*** 1295,1301 ****
  		/* Generate a partial append path. */
  		appendpath = create_append_path(rel, partial_subpaths, NULL,
  										parallel_workers);
! 		add_partial_path(rel, (Path *) appendpath);
  	}
  
  	/*
--- 1451,1457 ----
  		/* Generate a partial append path. */
  		appendpath = create_append_path(rel, partial_subpaths, NULL,
  										parallel_workers);
! 		add_partial_path(rel, (Path *) appendpath, false);
  	}
  
  	/*
*************** set_append_rel_pathlist(PlannerInfo *roo
*** 1346,1352 ****
  
  		if (subpaths_valid)
  			add_path(rel, (Path *)
! 					 create_append_path(rel, subpaths, required_outer, 0));
  	}
  }
  
--- 1502,1509 ----
  
  		if (subpaths_valid)
  			add_path(rel, (Path *)
! 					 create_append_path(rel, subpaths, required_outer, 0),
! 					 false);
  	}
  }
  
*************** generate_mergeappend_paths(PlannerInfo *
*** 1438,1450 ****
  														rel,
  														startup_subpaths,
  														pathkeys,
! 														NULL));
  		if (startup_neq_total)
  			add_path(rel, (Path *) create_merge_append_path(root,
  															rel,
  															total_subpaths,
  															pathkeys,
! 															NULL));
  	}
  }
  
--- 1595,1607 ----
  														rel,
  														startup_subpaths,
  														pathkeys,
! 														NULL), false);
  		if (startup_neq_total)
  			add_path(rel, (Path *) create_merge_append_path(root,
  															rel,
  															total_subpaths,
  															pathkeys,
! 															NULL), false);
  	}
  }
  
*************** set_dummy_rel_pathlist(RelOptInfo *rel)
*** 1576,1582 ****
  	rel->pathlist = NIL;
  	rel->partial_pathlist = NIL;
  
! 	add_path(rel, (Path *) create_append_path(rel, NIL, NULL, 0));
  
  	/*
  	 * We set the cheapest path immediately, to ensure that IS_DUMMY_REL()
--- 1733,1739 ----
  	rel->pathlist = NIL;
  	rel->partial_pathlist = NIL;
  
! 	add_path(rel, (Path *) create_append_path(rel, NIL, NULL, 0), false);
  
  	/*
  	 * We set the cheapest path immediately, to ensure that IS_DUMMY_REL()
*************** set_subquery_pathlist(PlannerInfo *root,
*** 1789,1795 ****
  		/* Generate outer path using this subpath */
  		add_path(rel, (Path *)
  				 create_subqueryscan_path(root, rel, subpath,
! 										  pathkeys, required_outer));
  	}
  }
  
--- 1946,1952 ----
  		/* Generate outer path using this subpath */
  		add_path(rel, (Path *)
  				 create_subqueryscan_path(root, rel, subpath,
! 										  pathkeys, required_outer), false);
  	}
  }
  
*************** set_function_pathlist(PlannerInfo *root,
*** 1858,1864 ****
  
  	/* Generate appropriate path */
  	add_path(rel, create_functionscan_path(root, rel,
! 										   pathkeys, required_outer));
  }
  
  /*
--- 2015,2021 ----
  
  	/* Generate appropriate path */
  	add_path(rel, create_functionscan_path(root, rel,
! 										   pathkeys, required_outer), false);
  }
  
  /*
*************** set_values_pathlist(PlannerInfo *root, R
*** 1878,1884 ****
  	required_outer = rel->lateral_relids;
  
  	/* Generate appropriate path */
! 	add_path(rel, create_valuesscan_path(root, rel, required_outer));
  }
  
  /*
--- 2035,2041 ----
  	required_outer = rel->lateral_relids;
  
  	/* Generate appropriate path */
! 	add_path(rel, create_valuesscan_path(root, rel, required_outer), false);
  }
  
  /*
*************** set_cte_pathlist(PlannerInfo *root, RelO
*** 1944,1950 ****
  	required_outer = rel->lateral_relids;
  
  	/* Generate appropriate path */
! 	add_path(rel, create_ctescan_path(root, rel, required_outer));
  }
  
  /*
--- 2101,2107 ----
  	required_outer = rel->lateral_relids;
  
  	/* Generate appropriate path */
! 	add_path(rel, create_ctescan_path(root, rel, required_outer), false);
  }
  
  /*
*************** set_worktable_pathlist(PlannerInfo *root
*** 1994,2000 ****
  	required_outer = rel->lateral_relids;
  
  	/* Generate appropriate path */
! 	add_path(rel, create_worktablescan_path(root, rel, required_outer));
  }
  
  /*
--- 2151,2158 ----
  	required_outer = rel->lateral_relids;
  
  	/* Generate appropriate path */
! 	add_path(rel, create_worktablescan_path(root, rel, required_outer),
! 			 false);
  }
  
  /*
*************** set_worktable_pathlist(PlannerInfo *root
*** 2007,2019 ****
   * path that some GatherPath has a reference to.)
   */
  void
! generate_gather_paths(PlannerInfo *root, RelOptInfo *rel)
  {
  	Path	   *cheapest_partial_path;
  	Path	   *simple_gather_path;
  
  	/* If there are no partial paths, there's nothing to do here. */
! 	if (rel->partial_pathlist == NIL)
  		return;
  
  	/*
--- 2165,2182 ----
   * path that some GatherPath has a reference to.)
   */
  void
! generate_gather_paths(PlannerInfo *root, RelOptInfo *rel, bool grouped)
  {
  	Path	   *cheapest_partial_path;
  	Path	   *simple_gather_path;
+ 	List	   *pathlist;
+ 	PathTarget *partial_target;
+ 
+ 	pathlist = !grouped ? rel->partial_pathlist :
+ 		rel->partial_grouped_pathlist;
  
  	/* If there are no partial paths, there's nothing to do here. */
! 	if (pathlist == NIL)
  		return;
  
  	/*
*************** generate_gather_paths(PlannerInfo *root,
*** 2027,2037 ****
  	 * could usefully generate such a path from each partial path that has
  	 * non-NIL pathkeys.
  	 */
! 	cheapest_partial_path = linitial(rel->partial_pathlist);
  	simple_gather_path = (Path *)
! 		create_gather_path(root, rel, cheapest_partial_path, rel->reltarget,
  						   NULL, NULL);
! 	add_path(rel, simple_gather_path);
  }
  
  /*
--- 2190,2203 ----
  	 * could usefully generate such a path from each partial path that has
  	 * non-NIL pathkeys.
  	 */
! 	cheapest_partial_path = linitial(pathlist);
! 
! 	partial_target = !grouped ? rel->reltarget : rel->reltarget_grouped;
! 
  	simple_gather_path = (Path *)
! 		create_gather_path(root, rel, cheapest_partial_path, partial_target,
  						   NULL, NULL);
! 	add_path(rel, simple_gather_path, grouped);
  }
  
  /*
*************** standard_join_search(PlannerInfo *root,
*** 2196,2202 ****
  			rel = (RelOptInfo *) lfirst(lc);
  
  			/* Create GatherPaths for any useful partial paths for rel */
! 			generate_gather_paths(root, rel);
  
  			/* Find and save the cheapest paths for this rel */
  			set_cheapest(rel);
--- 2362,2368 ----
  			rel = (RelOptInfo *) lfirst(lc);
  
  			/* Create GatherPaths for any useful partial paths for rel */
! 			generate_gather_paths(root, rel, false);
  
  			/* Find and save the cheapest paths for this rel */
  			set_cheapest(rel);
diff --git a/src/backend/optimizer/path/indxpath.c b/src/backend/optimizer/path/indxpath.c
new file mode 100644
index 7b43c4a..7c44938
*** a/src/backend/optimizer/path/indxpath.c
--- b/src/backend/optimizer/path/indxpath.c
*************** create_index_paths(PlannerInfo *root, Re
*** 338,344 ****
  		bitmapqual = choose_bitmap_and(root, rel, bitindexpaths);
  		bpath = create_bitmap_heap_path(root, rel, bitmapqual,
  										rel->lateral_relids, 1.0);
! 		add_path(rel, (Path *) bpath);
  	}
  
  	/*
--- 338,344 ----
  		bitmapqual = choose_bitmap_and(root, rel, bitindexpaths);
  		bpath = create_bitmap_heap_path(root, rel, bitmapqual,
  										rel->lateral_relids, 1.0);
! 		add_path(rel, (Path *) bpath, false);
  	}
  
  	/*
*************** create_index_paths(PlannerInfo *root, Re
*** 411,417 ****
  			loop_count = get_loop_count(root, rel->relid, required_outer);
  			bpath = create_bitmap_heap_path(root, rel, bitmapqual,
  											required_outer, loop_count);
! 			add_path(rel, (Path *) bpath);
  		}
  	}
  }
--- 411,417 ----
  			loop_count = get_loop_count(root, rel->relid, required_outer);
  			bpath = create_bitmap_heap_path(root, rel, bitmapqual,
  											required_outer, loop_count);
! 			add_path(rel, (Path *) bpath, false);
  		}
  	}
  }
*************** get_index_paths(PlannerInfo *root, RelOp
*** 785,791 ****
  		IndexPath  *ipath = (IndexPath *) lfirst(lc);
  
  		if (index->amhasgettuple)
! 			add_path(rel, (Path *) ipath);
  
  		if (index->amhasgetbitmap &&
  			(ipath->path.pathkeys == NIL ||
--- 785,791 ----
  		IndexPath  *ipath = (IndexPath *) lfirst(lc);
  
  		if (index->amhasgettuple)
! 			add_path(rel, (Path *) ipath, false);
  
  		if (index->amhasgetbitmap &&
  			(ipath->path.pathkeys == NIL ||
